Remove Unified Access Policies

Unified Access Policies (UAPs) let you grant and deny principals access to Google Cloud resources. If you no longer want a UAP to apply to a resource, you can delete the policy binding that binds the policy to the resource. If you want to remove a policy from all resources that it's bound to, you can delete the policy.

Before you begin

  1. Set up authentication.

    Select the tab for how you plan to use the samples on this page:

    Console

    When you use the Google Cloud console to access Google Cloud services and APIs, you don't need to set up authentication.

    gcloud

    In the Google Cloud console, activate Cloud Shell.

    Activate Cloud Shell

    At the bottom of the Google Cloud console, a Cloud Shell session starts and displays a command-line prompt. Cloud Shell is a shell environment with the Google Cloud CLI already installed and with values already set for your current project. It can take a few seconds for the session to initialize.

    REST

    To use the REST API samples on this page in a local development environment, you use the credentials you provide to the gcloud CLI.

      Install the Google Cloud CLI.

      If you're using an external identity provider (IdP), you must first sign in to the gcloud CLI with your federated identity.

    For more information, see Authenticate for using REST in the Google Cloud authentication documentation.

  2. Verify that billing is enabled for your Google Cloud project.

  3. Optional: Read the overview of UAPs.

Roles required to delete Unified Access Policy bindings

To get the permissions that you need to delete a binding for a UAP, ask your administrator to grant you the following IAM roles:

  • Access Policy User (roles/iam.accessPolicyUser) on the resource that owns the UAP. This role includes the iam.accesspolicies.unbind permission, which is required to delete bindings.
  • A role that includes the permission SERVICE.RESOURCE.deletePolicyBinding, where RESOURCE is the resource type that the UAP is bound to and SERVICE is the service that owns the resource.

    To find a role that includes the required permission, search for the permission in the role and permission reference, click the permission name, and then review the roles that include the permission.

    You need this role on the resource or one of its ancestors.

For more information about granting roles, see Manage access to projects, folders, and organizations.

Roles required to delete Unified Access Policies

To get the permissions that you need to delete UAPs, ask your administrator to grant you the Access Policy Admin (roles/iam.accessPolicyAdmin) IAM role on the project, folder, or organization that owns the UAP that you want to delete. For more information about granting roles, see Manage access to projects, folders, and organizations.

This predefined role contains the permissions required to delete UAPs. To see the exact permissions that are required, expand the Required permissions section:

Required permissions

The following permissions are required to delete UAPs:

  • iam.accesspolicies.delete
  • Delete UAPs in the Google Cloud console:
    • iam.accesspolicies.get
    • iam.accessPolicies.list

You might also be able to get these permissions with custom roles or other predefined roles.

Remove a Unified Access Policy from a resource

To remove a UAP from a resource, delete the binding that binds the UAP to the resource. After you delete the binding, the UAP no longer applies to the resource or the resource's descendants. However, the UAP is not deleted and none of its other bindings are affected.

You can delete bindings for projects, folders, and organizations using the Google Cloud console, the gcloud CLI, or the IAM REST API. To delete bindings for other resources, you must use the gcloud CLI or the IAM REST API.

Console

  1. In the Google Cloud console, go to the Unified Access Policies page.

    Go to Unified Access Policies
  2. Select the project, folder, or organization that owns the UAP that you want to remove.
  3. Click the policy ID of the UAP that you want to remove.
  4. Select the Bindings tab.
  5. In the Bindings table, find the row containing the binding that you want to remove.
  6. In that row, click the Actions menu, and then click Delete binding.
  7. In the Delete binding dialog, click Delete.

gcloud

The gcloud iam policy-bindings delete command deletes a binding.

Before using any of the command data below, make the following replacements:

  • BINDING_ID: The ID of the binding that you want to delete—for example, example-binding.
  • BINDING_PARENT_RESOURCE_TYPE: The type of the Resource Manager resource (project, folder, or organization) that the binding is a child of. Use the value project, folder, or organization.

    The binding's parent resource depends on the target resource in the binding. For more information, see Supported resources.

  • BINDING_PARENT_RESOURCE_ID: The ID of the project, folder, or organization that the policy binding is a child of. Project IDs are alphanumeric strings, like my-project. Folder and organization IDs are numeric, like 123456789012.

Execute the following command:

Linux, macOS, or Cloud Shell

gcloud iam policy-bindings delete BINDING_ID \
    --BINDING_PARENT_RESOURCE_TYPE=BINDING_PARENT_RESOURCE_ID --location=global

Windows (PowerShell)

gcloud iam policy-bindings delete BINDING_ID `
    --BINDING_PARENT_RESOURCE_TYPE=BINDING_PARENT_RESOURCE_ID --location=global

Windows (cmd.exe)

gcloud iam policy-bindings delete BINDING_ID ^
    --BINDING_PARENT_RESOURCE_TYPE=BINDING_PARENT_RESOURCE_ID --location=global

The response contains a long-running operation representing your request. To learn how to get the status of a long-running operation, see Check the status of a long-running operation on this page.

Delete request issued for: [example-binding]
Waiting for operation [organizations/123456789012/locations/global/operations/operation-1715374724030-6181fcd1520c5-d21b0a12-b704e1ce] to complete...done.
Deleted policyBinding [example-binding].

REST

The policyBindings.delete method deletes a binding.

Before using any of the request data, make the following replacements:

  • BINDING_PARENT_RESOURCE_TYPE: The type of the Resource Manager resource (project, folder, or organization) that the binding is a child of. Use the value projects, folders, or organizations.

    The binding's parent resource depends on the target resource in the binding. For more information, see Supported resources.

  • BINDING_PARENT_RESOURCE_ID: The ID of the project, folder, or organization that the policy binding is a child of. Project IDs are alphanumeric strings, like my-project. Folder and organization IDs are numeric, like 123456789012.
  • BINDING_ID: The ID of the binding that you want to delete—for example, example-binding.

HTTP method and URL:

DELETE https://iam.googleapis.com/v3/BINDING_PARENT_RESOURCE_TYPE/BINDING_PARENT_RESOURCE_ID/locations/global/policyBindings/BINDING_ID

To send your request, expand one of these options:

The response contains a long-running operation representing your request. To learn how to get the status of a long-running operation, see Check the status of a long-running operation on this page.

{
  "name": "organizations/123456789012/locations/global/operations/operation-1715373190994-6181f71b4daad-6d8168c1-13cc6600",
  "metadata": {
    "@type": "type.googleapis.com/google.iam.v3.OperationMetadata",
    "createTime": "2026-05-10T20:33:11.165728913Z",
    "target": "organizations/123456789012/locations/global/policyBindings/example-binding",
    "verb": "delete",
    "requestedCancellation": false,
    "apiVersion": "v3"
  },
  "done": false
}

Delete a Unified Access Policy

Before you delete a UAP, identify and delete all existing bindings that reference the UAP. Attempts to delete a UAP without deleting existing bindings result in an error.

If you want to delete a UAP without deleting existing bindings, then you can forcefully delete the UAP. Forcefully deleting a UAP removes it from all of the resources that it's bound to. Any bindings that reference the UAP will eventually be deleted. However, until they are deleted, the bindings still count against the limit of the number of bindings that can refer to a single resource.

You can delete UAPs using the Google Cloud console, the gcloud CLI, or the IAM REST API.

Console

  1. In the Google Cloud console, go to the Unified Access Policies page.

    Go to Unified Access Policies
  2. Select the project, folder, or organization that owns the UAP that you want to delete.
  3. Click the policy ID of the UAP that you want to delete.
  4. Click Delete policy.
  5. If the UAP has existing bindings, then select Delete this policy and all of its bindings. If you try to delete a UAP with existing bindings without selecting this option, then the request fails.
  6. In the Delete policy dialog, click Delete.

gcloud

The gcloud iam access-policies delete command deletes a UAP and all associated bindings.

Before using any of the command data below, make the following replacements:

  • UAP_ID: The ID of the UAP that you want to delete—for example, example-policy.
  • UAP_PARENT_RESOURCE_TYPE: The type of the Resource Manager resource (project, folder, or organization) that owns the UAP that you want to delete. Use the value project, folder, or organization.
  • UAP_PARENT_RESOURCE_ID: The ID of the project, folder, or organization that owns the UAP that you want to delete. Project IDs are alphanumeric strings, like my-project. Folder and organization IDs are numeric, like 123456789012.
  • FORCE_FLAG: Optional. To force the command to delete a policy, even if that policy is referenced in existing bindings, use the flag --force. If this flag is not set and the policy is referenced in existing bindings, then the command fails.

Execute the following command:

Linux, macOS, or Cloud Shell

gcloud iam access-policies delete UAP_ID \
    --UAP_PARENT_RESOURCE_TYPE=UAP_PARENT_RESOURCE_ID --location=global \
    FORCE_FLAG

Windows (PowerShell)

gcloud iam access-policies delete UAP_ID `
    --UAP_PARENT_RESOURCE_TYPE=UAP_PARENT_RESOURCE_ID --location=global `
    FORCE_FLAG

Windows (cmd.exe)

gcloud iam access-policies delete UAP_ID ^
    --UAP_PARENT_RESOURCE_TYPE=UAP_PARENT_RESOURCE_ID --location=global ^
    FORCE_FLAG

The response contains a long-running operation representing your request. To learn how to get the status of a long-running operation, see Check the status of a long-running operation on this page.

Delete request issued for: [example-policy]
Waiting for operation [organizations/123456789012/locations/global/operations/operation-1715374811191-6181fd2471ab4-f0947406-85778c43] to complete...done.
Deleted accessPolicy [example-policy].

REST

The accessPolicies.delete method deletes a UAP and all associated bindings.

Before using any of the request data, make the following replacements:

  • UAP_PARENT_RESOURCE_TYPE: The type of the Resource Manager resource (project, folder, or organization) that owns the UAP that you want to delete. Use the value projects, folders, or organizations.
  • UAP_PARENT_RESOURCE_ID: The ID of the project, folder, or organization that owns the UAP that you want to delete. Project IDs are alphanumeric strings, like my-project. Folder and organization IDs are numeric, like 123456789012.
  • UAP_ID: The ID of the UAP that you want to delete—for example, example-policy.
  • FORCE_DELETE: Optional. To force the request to delete the policy, even if the policy is referenced in existing bindings, add the query parameter force=true. If this query parameter is not set and the policy is referenced in existing bindings, then the request fails.

HTTP method and URL:

DELETE https://iam.googleapis.com/v3/UAP_PARENT_RESOURCE_TYPE/UAP_PARENT_RESOURCE_ID/locations/global/accessPolicies/UAP_ID?FORCE_DELETE

To send your request, expand one of these options:

The response contains a long-running operation representing your request. To learn how to get the status of a long-running operation, see Check the status of a long-running operation on this page.

{
  "name": "organizations/123456789012/locations/global/operations/operation-1715373190994-6181f71b4daad-6d8168c1-13cc6600",
  "metadata": {
    "@type": "type.googleapis.com/google.iam.v3.OperationMetadata",
    "createTime": "2026-05-10T20:33:11.165728913Z",
    "target": "organizations/123456789012/locations/global/accessPolicies/example-policy",
    "verb": "delete",
    "requestedCancellation": false,
    "apiVersion": "v3"
  },
  "done": false
}

Check the status of a long-running operation

When you use the REST API or the client libraries, any method that changes a policy or binding returns a long-running operation (LRO). The long-running operation tracks the status of the request and indicates whether the change to the policy or binding is complete.

REST

The operations.get method returns the status of a long-running operation.

Before using any of the request data, make the following replacements:

  • OPERATION_NAME: The full name of the operation. You receive this name in the response to your original request.

    The operation name has the following format:

    RESOURCE_TYPE/RESOURCE_ID/locations/global/operations/OPERATION_ID
        

HTTP method and URL:

GET https://iam.googleapis.com/v3/OPERATION_NAME

To send your request, expand one of these options:

You should receive a JSON response similar to the following:

{
  "name": "organizations/314340013352/locations/global/operations/operation-1732752311821-627edd607a3df-9a62cdea-2a7d9f07",
  "metadata": {
    "@type": "type.googleapis.com/google.iam.v3.OperationMetadata",
    "createTime": "2024-11-28T00:05:12.006289686Z",
    "endTime": "2024-11-28T00:05:12.192141801Z",
    "target": "organizations/314340013352/locations/global/POLICY_TYPE/POLICY_ID",
    "verb": "create",
    "requestedCancellation": false,
    "apiVersion": "v3"
  },
  "done": true,
  "response": {
    POLICY
  }
}

If the operation's done field is not present, continue to monitor its status by getting the operation repeatedly. Use truncated exponential backoff to introduce a delay between each request. When the done field is set to true, the operation is complete, and you can stop getting the operation.

What's next